osl::PtypePlayerTraits< T, P > Struct Template Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Static Public Member Functions | List of all members
osl::PtypePlayerTraits< T, P > Struct Template Reference

`#include <ptypeTraits.h>`

## Static Public Member Functions
static bool | canDropTo (Square, Int2Type< false >)
static bool | canDropTo (Square pos, Int2Type< true >)
static bool | canDropTo (Square pos)
static bool | mayPromote (Square pos, Int2Type< true >)
| posにある駒がpromoteする可能性があるか? 先手BISHOPが49,58,59,69などにいる場合は可能性がないが，この時点では排除しない More...
static bool | mayPromote (Square pos)
static bool | mustPromote (Square pos)
| posにあるTの駒がpromoteする手しかない More...
static bool | canPromote (Square pos)
| posにあるTの駒がどの方向に動いてもpromote可能 More...
static bool | checkPromote (Square pos)
| posにあるTの駒がpromote可能なdirectionに動く時だけpromote可能 shortの時はその時のみYES More...
static bool | noPromote (Square pos)
| posにあるTの駒は次に絶対にpromoteできない More...

## Detailed Description

### template<Ptype T, Player P>
struct osl::PtypePlayerTraits< T, P >

Definition at line 369 of file ptypeTraits.h.

## Member Function Documentation

template<Ptype T, Player P>

static bool osl::PtypePlayerTraits< T, P >::canDropTo | ( | Square | ,
|  | Int2Type< false > |
| ) |  |
| inlinestatic

Definition at line 371 of file ptypeTraits.h.

Referenced by osl::PtypePlayerTraits< T, P >::canDropTo(), osl::effect_action::BetterToPromote< Action >::doAction(), osl::effect_action::BetterToPromote< Action >::doActionPtype(), osl::effect_action::AlwaysMove< Action >::doActionPtype(), osl::move_generator::escape::generateDrop(), and osl::move_generator::addeffect8::generateShortMove().

template<Ptype T, Player P>

static bool osl::PtypePlayerTraits< T, P >::canDropTo | ( | Square | pos,
|  | Int2Type< true > |
| ) |  |
| inlinestatic

Definition at line 376 of file ptypeTraits.h.

References osl::BLACK, osl::Square::reverseY(), and osl::Square::y().

template<Ptype T, Player P>

static bool osl::PtypePlayerTraits< T, P >::canDropTo | ( | Square | pos) |  |
| inlinestatic

Definition at line 386 of file ptypeTraits.h.

References osl::PtypePlayerTraits< T, P >::canDropTo().

template<Ptype T, Player P>

static bool osl::PtypePlayerTraits< T, P >::canPromote | ( | Square | pos) |  |
| inlinestatic

posにあるTの駒がどの方向に動いてもpromote可能

Definition at line 428 of file ptypeTraits.h.

References osl::BLACK, osl::KNIGHT, osl::LANCE, osl::PAWN, osl::Square::yGe(), and osl::Square::yLe().

template<Ptype T, Player P>

static bool osl::PtypePlayerTraits< T, P >::checkPromote | ( | Square | pos) |  |
| inlinestatic

posにあるTの駒がpromote可能なdirectionに動く時だけpromote可能 shortの時はその時のみYES

Definition at line 445 of file ptypeTraits.h.

References osl::BISHOP, osl::BLACK, osl::LANCE, osl::ROOK, osl::SILVER, and osl::Square::yEq().

template<Ptype T, Player P>

static bool osl::PtypePlayerTraits< T, P >::mayPromote | ( | Square | pos,
|  | Int2Type< true > |
| ) |  |
| inlinestatic

posにある駒がpromoteする可能性があるか? 先手BISHOPが49,58,59,69などにいる場合は可能性がないが，この時点では排除しない

Definition at line 394 of file ptypeTraits.h.

References osl::BLACK, osl::Square::reverseY(), and osl::Square::y().

Referenced by osl::PtypePlayerTraits< T, P >::mayPromote().

template<Ptype T, Player P>

static bool osl::PtypePlayerTraits< T, P >::mayPromote | ( | Square | pos) |  |
| inlinestatic

Definition at line 404 of file ptypeTraits.h.

References osl::PtypePlayerTraits< T, P >::mayPromote().

template<Ptype T, Player P>

static bool osl::PtypePlayerTraits< T, P >::mustPromote | ( | Square | pos) |  |
| inlinestatic

posにあるTの駒がpromoteする手しかない

Definition at line 412 of file ptypeTraits.h.

References osl::BLACK, osl::KNIGHT, osl::LANCE, osl::PAWN, osl::Square::yEq(), osl::Square::yGe(), and osl::Square::yLe().

template<Ptype T, Player P>

static bool osl::PtypePlayerTraits< T, P >::noPromote | ( | Square | pos) |  |
| inlinestatic

posにあるTの駒は次に絶対にpromoteできない

Definition at line 463 of file ptypeTraits.h.

References osl::BISHOP, osl::BLACK, osl::KNIGHT, osl::LANCE, osl::PAWN, osl::ROOK, osl::SILVER, osl::Square::yGe(), and osl::Square::yLe().

The documentation for this struct was generated from the following file:

- ptypeTraits.h